//---------------------------------------------------------------------------
#ifndef BpddEH
#define BpddEH
//---------------------------------------------------------------------------
#include "IpAdr.h"
//---------------------------------------------------------------------------
#pragma pack(push,1)       //   BYTE
//---------------------------------------------------------------------------
//   
enum {TYPE_BPDDE=1,TYPE_KKDE=2,TYPE_BSK=3};

struct SAT_FIND_BPDD
{
    char str[16];
    SAT_FIND_BPDD(unsigned char type)
    {
        ZeroMemory(str,sizeof(str));
        lstrcpy(str,"SATURN_FIND_1");
        str[12]=type+0x30;
    }
};
//---------------------------------------------------------------------------
// EPROM - ( -)
//---------------------------------------------------------------------------
#define BPDD_EPROM_MYIP   	 (1)	// IP  : 		 1-4
#define BPDD_EPROM_MYMAC  	 (5)	// MAC : 		 5-10
#define BPDD_EPROM_MYMASK    (11)	// :				11-14
#define BPDD_EPROM_MYGATEWAY (15)	//Gateway :				15-18
#define BPDD_EPROM_MYNUMBER  (19)	// :				19-20
#define BPDD_EPROM_SMTP      (21)	//SMTP  -   21-24
#define EPROM_SYMBOLGAP      (21)	// v1.2:  -   21
#define EPROM_NEEDOPEN       (21)	//2      21
#define EPROM_DISABLE4001    (22)	// v1.4:   4001       22
#define EPROM_ENABLE3000     (23)   //v1.6:   3000   23
#define BPDD_EPROM_FLAGS     (25)	// - DHCP (1 ) 25
#define EPROM_USEDALLAS      (25)	//KKD-E: 0-  TouchMemory, !0-
//#define BPDD_EPROM_FTP       (26)	//SMTP  -    26-29
#define EPROM_PPK_STRATEGY   (26)	// -  
#define EPROM_PPK_DELAY      (27)	// -  / 
#define KKDE_DHCP_FLAGS      (28)   //-  DHCP    1.6 (- - 2.6)
//APP_CONFIG: 1..29
//  TCP 
#define BPDD_EPROM_ACTIVITY  (30)
//   
#define BPDD_EPROM_BAUD_L    (32)
#define BPDD_EPROM_BAUD_H    (33)
// -
#define BPDD_EPROM_BPDDCONFIG  (34)
//16   
#define BPDD_EPROM_TEXTLABEL   (35)
//8  - 
#define BPDD_EPROM_LOGIN       (51)
//8  - 
#define BPDD_EPROM_PASSWORD    (59)
//32  -  Access List (4  ALLOWED_NET)
#define BPDD_EPROM_ACCESSLIST  (67)
//   EPROM
#define EPROM_RELE        (99)
//  
#define EPROM_OPENTIME     (100)
// 
#define EPROM_RESETCNT     (101)  //101- , 102-

//-------------------------------------------------------
// -
union BPDD_CONFIG
{
	unsigned char Byte;
	struct
	{
		unsigned char Rs485:1; 	    // 0 - 0-RS232 1-RS485
		unsigned char AddStop:1; 	// 1 - 0:1 ,1:2 
		unsigned char Parity:2; 	// 2,3- 
		unsigned char Telnet:1; 	// 4 - 1-   TelNet 0-
		unsigned char Broadcast:1;  // 5 1- Broadcast  (  1)
		unsigned char Debug:1; 	    // 6 1-   
        unsigned char RtsCts:1;     // 7 1-RTS/CTS 0- 
	};
};
//---------------------------------------------------------------------------
struct ALLOWED_NET
{
	IPADR Adr;		//     
	IPADR Mask;	    //     
};
//---------------------------------------------------------------------------
//   EPROM  -
struct SAT_FIND_INFO_BPDD
{
	char Type;				    //EPROM   -  'I'
    unsigned char Stored;       //0      0x5A   EPROM  
    IPADR Ip;			        //1-4    IP  (Local Source)
    MACADR Mac;			        //5-10  MAC 
    IPADR SubNetMask;  	        //11-15  
    IPADR GateWay;		        //15-18 IP   (Gateway)
    unsigned short int SerNum;  //19-20  
	//IPADR SmtpServer;       //21-24 SMTP  -  
	union
    {
    unsigned char SymbolGap;    //21  v1.2:  
    unsigned char NeedOpenTime; //21 2-      21
    };
    unsigned char Disable4001;  //22  v1.4: Disable4001
    union
    {
    unsigned char OpticTamper;  //23 - v1.1:   
    unsigned char EnableUDP;    //23 - v1.6:   3000
    };
    unsigned char Reserv;       //24
    union
    {
		unsigned char NetFlag;  //25     -   (1 )
		unsigned char UseDallas;
	};
	//IPADR Ftp;			        //26-29 FTP  -  
	unsigned char Strategy;     	//26 - - 
	unsigned char PpkDelay;      	//27 -  -  / 
	unsigned char KkdeDhcp;     	//28 - -  - -  DHCP (0=1-,=0-)
	unsigned char Unused2;     		//29

	unsigned short int TcpActivity;  //30-31   TCP  ()
	unsigned short int  BaudVal;//32-33    . 
	BPDD_CONFIG Flags;          //34     -
	unsigned char Text[16];		//35-50  -16 
	unsigned char Login[8];		//51-58  -  8 
	unsigned char Password[8];	//59-66  -  8 
	ALLOWED_NET  Nets[4];       //67-98
	//unsigned char Reserved[29]; //99-127 (v1.0)
	unsigned char Rele;         //99    EPROM (-2)
	unsigned char OpenTime;     //100   (-2 v1.1)
	unsigned short int ResetCounter; //101-102  (-2 v1.1)
	unsigned char Reserved[25]; //103-127
	unsigned char VersionL;     //128   . 
	unsigned char VersionH;     //129   . 
	unsigned char FlashAdrH;    //130   .    

	bool IsSame(SAT_FIND_INFO_BPDD * sfi)
	{
		//  MAC 
		if(Mac!=sfi->Mac)               return false;
		//  IP 
		if(Ip!=sfi->Ip)                 return false;
		//   
		if(GateWay!=sfi->GateWay)       return false;
        return true;
    }
    //String FileName(void);
    //      -
    bool IsFirstVersion(void)
    {
        if(VersionL!=0)return false;
        if(VersionH!=1)return false;
        return true;
    }
};
//---------------------------------------------------------------------------
//  ETHERNET  (    1.0)
//    ,   
//    UDP     0
struct CMD_BPDDE
{
	char Type;				    //0 	  
    MACADR Mac;                 //1..6     
    unsigned short int Adr;     //7,8 	 
    unsigned char Len;          //9 	      EPROM
    unsigned char Ks;           //10       
    char Data[64];              //11..74     EPROM
                                //		   75 
    CMD_BPDDE(char type,MACADR mac)
    {
        ZeroMemory(this,sizeof(CMD_BPDDE));
        Type=type;
        Mac=mac;
    }
    //  
    void FillKs(void);

};
#define CMDLEN  (sizeof(CMD_BPDDE)-64)
//---------------------------------------------------------------------------
// OK   
struct ANSWER_OK_BPDDE
{
	char Type;				    //0 	 
    char SymbolO;               //1
    char SymbolK;               //2
    bool IsOK(char type)
    {
        if(type    != Type)return false;
        if(SymbolO != 'O')return false;
        if(SymbolK != 'K')return false;
        return true;
    };
};
//---------------------------------------------------------------------------
//     
struct ANSWER_BPDDE
{
	char Type;				    //0 	 
    char Byte1;                 //1
    char Byte2;                 //2
    char Data[64];              //

    bool IsOK(char type)
    {
        if(type != Type)return false;
        return true;
    };
};
//---------------------------------------------------------------------------
struct STATUS_INFO_BPDD
{
	unsigned short int  InRxSize;		//    
	unsigned short int  InTxSize;		//    
	unsigned short int  RxSize;		    //  
	unsigned short int  TxSize;		    //  
	unsigned short int  ParityErrorCnt; //   UART
	unsigned short int  RxOverErrorCnt; //   
	unsigned short int  RxErrorCnt;	    //   . 
	unsigned char UartFlag;		        //  UART
	unsigned char BpddConfig;	        // -
	//   B
	unsigned char PORTB;	            //  POTRB
	unsigned char LATB;	                //  LATB
	//   C
	unsigned char PORTC;	            //  POTRC
	unsigned char LATC;	                //  LATC
};
//---------------------------------------------------------------------------
#pragma pack(pop)
//---------------------------------------------------------------------------
#endif
