//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "IpAdr.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
//   Hex(0-F)
//---------------------------------------------------------------------------
extern char C2D(unsigned char c);
//---------------------------------------------------------------------------
//  char *
IPADR::IPADR(char * str)
{
    Clear();
    for(int i=0;i<4;i++)
    {
        //  ?
        if(!*str)break;
        Byte[i]=atoi(str);
        // 
        while(*str)
        {
            if(*str++=='.')break;
        }
    }
}
//---------------------------------------------------------------------------
//  String &
IPADR::IPADR(String  s)
{
  *this=IPADR(s.c_str());
}
//---------------------------------------------------------------------------
//   String
IPADR::operator String()
{
    return  IntToStr(Byte[0]&0xFF)+(String)"."+
            IntToStr(Byte[1]&0xFF)+(String)"."+
            IntToStr(Byte[2]&0xFF)+(String)"."+
            IntToStr(Byte[3]&0xFF);
}
//---------------------------------------------------------------------------
//  
bool IPADR::operator == (IPADR ip)
{
    return AsLong==ip.AsLong;
}
//---------------------------------------------------------------------------
//  
bool IPADR::operator != (IPADR ip)
{
    return AsLong!=ip.AsLong;
}
//---------------------------------------------------------------------------
//  
IPADR IPADR::operator &(IPADR ip)
{
    ip.AsLong&=AsLong;
    return ip;
}
//---------------------------------------------------------------------------
//MACADR
//---------------------------------------------------------------------------
//  char *
// MAC   hex 
MACADR::MACADR(char * str)
{
    Clear();

	unsigned char i=0;		//  Byte
	unsigned char num=0;	// 
	unsigned char byte;		//

#pragma warn -pia
	while(byte=*str++) //  
#pragma warn +pia
	{
		// 
		if(byte==(unsigned char)'-')
		{
			//  
			Byte[i++]=num;
			if(i>=(unsigned char)6)return;
			num=0;
			continue;
		}
		//  
		if(byte==(unsigned char)C2D(byte))continue;
		//  hex 
		num<<=4;
		num+=C2D(byte);
	}
	// 0
	Byte[i]=num;
}
//---------------------------------------------------------------------------
//  String &
MACADR::MACADR(String  s)
{
  *this=MACADR(s.c_str());
}
//---------------------------------------------------------------------------
//   String
MACADR::operator String()
{
    String s;
    for(int i=0;i<6;i++)
    {
        s=s+IntToHex(Byte[i]&0xFF,2);
        if(i<5)s=s+"-";
    }
    return  s;
}
//---------------------------------------------------------------------------
//  
bool MACADR::operator == (MACADR mac)
{
    for(int i=0;i<6;i++)if(Byte[i]!=mac.Byte[i])return 0;
    return 1;
}
//---------------------------------------------------------------------------
//  
bool MACADR::operator != (MACADR mac)
{
    return ! operator == (mac);
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//   IP  
//: true-  IP 
//       false- IP 
bool IPADR::ExtractValidIP(const char * ipstr)
{
	char str[64];
	lstrcpyn(str,ipstr,sizeof(str));
	// 
	Clear();
	int len=lstrlen(str);
	if(!len)return false;	//  IP 
	BYTE dotcnt;
	BYTE figcnt;
	int last;
	IPADR ip;
	//,   IP    
	dotcnt=0;
	figcnt=0;
	last=0;
	for(int i=0;i<len;i++)
	{
		if(str[i]=='.')
		{
			//  
			//    
			if(!figcnt)
			{
				// 
				return false;
			}
			//  
			str[i]=0;
			int val=atoi(str+last);
			if(val>255)
			{
				// 
				return false;
			}
			//  
			ip.Byte[dotcnt]=val;
			dotcnt++;
			if(dotcnt>3u)
			{
				// 
				return false;
			}
			figcnt=0;
			last=i+1;
			continue;
		}
		if(str[i]<(BYTE)0x30 || str[i]>(BYTE)0x39)
		{
			// 
			return false;
		}
		// 
		figcnt++;
	}
	//  
	if(dotcnt!=3u)
	{
		//  
		return false;
	}
	//  
	if(!figcnt)
	{
		// 
		return false;
	}
	//  
	int val=atoi(str+last);
	if(val>255)
	{
		// 
		return false;
	}
	//  
	ip.Byte[dotcnt]=val;
	AsLong=ip.AsLong;
	return true;
}
//---------------------------------------------------------------------------

