//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Bpdde.h"
#include "UMain.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFormTest *FormTest;
//---------------------------------------------------------------------------
#define Status(x)  StatusBar1->Panels->Items[x]->Text
#define BIT(x)     (1<<x)
//---------------------------------------------------------------------------
__fastcall TFormTest::TFormTest(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFormTest::FormCreate(TObject *Sender)
{
    CloseLibrary();
}
//---------------------------------------------------------------------------

void __fastcall TFormTest::FormClose(TObject *Sender, TCloseAction &Action)
{
    CloseLibrary();
}
//---------------------------------------------------------------------------
void TFormTest::CloseLibrary(void)
{
    if(Library)
    {
        FreeLibrary(Library);
        Library=NULL;
    }
    PanelFind->Visible=false;
    InFind=false;
    StartFind=NULL;
    StopFind=NULL;
    GetFindCount=NULL;
    GetKpu=NULL;
    GetError=NULL;
    EnableLog=NULL;
    SetKpu=NULL;
    ListBoxKpu->Clear();
    ZeroMemory(Si,sizeof(Si));
    KpuCount=0;
    EditIndex=-1;
    InFind=false;
    Status(0) ="";
}
//---------------------------------------------------------------------------
bool TFormTest::OpenLibrary(void)
{
    AnsiString filename="Dll\\Kpu.dll";
    CloseLibrary();
    //  
    if(!FileExists(filename))return false;
    //  
    Library=LoadLibrary(filename.c_str());
    if(!Library)return false;
    //    
    StartFind=(STARTFIND)GetProcAddress(Library,"@StartFind$qv");
    StopFind=(STOPFIND)GetProcAddress(Library,"@StopFind$qv");
    GetFindCount=(GETFINDCOUNT)GetProcAddress(Library,"@GetFindCount$qv");
    GetKpu=(GETKPU)GetProcAddress(Library,"@GetKpu$qipv");
    GetError=(GETERROR)GetProcAddress(Library,"@GetError$qpci");
    EnableLog=(ENABLELOG)GetProcAddress(Library,"@EnableLog$qv");
    SetKpu=(SETKPU)GetProcAddress(Library,"@SetKpu$qipv");
    if(!StartFind || !StopFind ||!GetFindCount || !GetKpu || !GetError ||
       !EnableLog || !SetKpu)
    {
        CloseLibrary();
        return false;
    }
    //  
    return true;
}
//---------------------------------------------------------------------------
void __fastcall TFormTest::ButtonLoadClick(TObject *Sender)
{
    if(OpenLibrary())
    {
        PanelFind->Visible=true;
        Status(0)=" ...";
    }
}
//---------------------------------------------------------------------------

void __fastcall TFormTest::ButtonStartFindClick(TObject *Sender)
{
    LabelResult->Caption="";
    ListBoxKpu->Clear();
    ZeroMemory(Si,sizeof(Si));
    KpuCount=0;
    EditIndex=-1;
    if(StartFind)
    {
        int res=StartFind();
        if(res)
        {
            StartTick=GetTickCount();
            InFind=true;
        }
        else
        {
            Status(1)="   ...";
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TFormTest::ButtonStopFindClick(TObject *Sender)
{
    if(StopFind)
    {
        StopFind();
        InFind=false;
    }
}
//---------------------------------------------------------------------------

void __fastcall TFormTest::ButtonKpuClick(TObject *Sender)
{
    if(!GetFindCount)return;
    int cnt=GetFindCount();
    Status(0) =" : "+IntToStr(cnt);
    while(KpuCount<cnt)
    {
        //   EPROM  -
        SAT_FIND_INFO_BPDD si;
        if(GetKpu(KpuCount,(void *)&si))
        {
            char s[17];
            memcpy(s,si.Text,16);
            s[16]=0;
            AnsiString ip=si.Ip;
            ListBoxKpu->Items->Add(ip+" ("+s+")");
            Si[KpuCount]=si;
        }
        KpuCount++;
    }
}
//---------------------------------------------------------------------------

void __fastcall TFormTest::Timer1Timer(TObject *Sender)
{
    if(!InFind)
    {
        Status(1) ="";
        return;
    }
    UINT tm=GetTickCount()-StartTick;
    Status(1) =" : "+IntToStr(tm/1000)+" ";
}
//---------------------------------------------------------------------------

void __fastcall TFormTest::ButtonErrClick(TObject *Sender)
{
    if(!GetError)return;
    char err[256];
    GetError(err,sizeof(err));
    Status(1)=err;
}
//---------------------------------------------------------------------------

void __fastcall TFormTest::ListBoxKpuClick(TObject *Sender)
{
    LabelResult->Caption="";
    EditIndex=-1;
    EditIp->Text="";
    EditMask->Text="";
    EditGateWay->Text="";
    int index=ListBoxKpu->ItemIndex;
    if(index<0 || index>=KpuCount)return;
    SAT_FIND_INFO_BPDD * si=&Si[index];
    if(si->Type!='I')return;
    EditIndex=index;
	char s[32];
	memcpy(s,si->Text,16);
	s[16]=0;
	if(s[0]==-1)s[0]=0;
	//
	LabelName->Caption=(AnsiString)s+"  :"+IntToStr(si->VersionH)+"."+IntToStr(si->VersionL);
	// IP 
	EditIp->Text=si->Ip;
	// 
	EditMask->Text=si->SubNetMask;
	//IP  
	EditGateWay->Text=si->GateWay;
	CheckBoxDHCP->Checked=(si->NetFlag & BIT(0));
/*
	//Login
	memcpy(s,Si->Login,8);
	s[8]=0;
	EditLogin->Text=s;
	//Password
	memcpy(s,Si->Password,8);
	s[8]=0;
	EditPassword->Text=s;
	//MAC 
	EditMAC->Text=Si->Mac;
	// 
	RadioGroupNet->ItemIndex=Si->Nets[0].Adr.Byte[0]?1:0;
	NET_ADR(1)=Si->Nets[0].Adr;
	NET_MASK(1)=Si->Nets[0].Mask;
	NET_ADR(2)=Si->Nets[1].Adr;
	NET_MASK(2)=Si->Nets[1].Mask;
	NET_ADR(3)=Si->Nets[2].Adr;
	NET_MASK(3)=Si->Nets[2].Mask;
	NET_ADR(4)=Si->Nets[3].Adr;
	NET_MASK(4)=Si->Nets[3].Mask;
	// 
	CheckBoxNet2->Checked=Si->Nets[1].Adr.Byte[0];
	CheckBoxNet3->Checked=Si->Nets[2].Adr.Byte[0];
	CheckBoxNet4->Checked=Si->Nets[3].Adr.Byte[0];

	// Broadcast 
	CheckBoxBroadCast->Checked=Si->Flags.Broadcast;

	//   TelNet 0-
	CheckBoxTelnet->Checked=Si->Flags.Telnet;

*/
}
//---------------------------------------------------------------------------

void __fastcall TFormTest::ButtonChangeClick(TObject *Sender)
{
    if(EditIndex<0 || EditIndex>=KpuCount)return;
    SAT_FIND_INFO_BPDD * si=&Si[EditIndex];
    // IP 
    si->Ip=(IPADR)EditIp->Text;
    // 
    si->SubNetMask=(IPADR)EditMask->Text;
    //IP  
    si->GateWay=(IPADR)EditGateWay->Text;
    si->NetFlag=(unsigned char)((CheckBoxDHCP->Checked)?1:0);
    if(SetKpu)
    {
        int res=SetKpu(EditIndex,(void *)si);
        if(res)LabelResult->Caption=" ...";
        else   LabelResult->Caption="  ...";
    }
}
//---------------------------------------------------------------------------

